\documentclass[a4paper,UTF8]{ctexart}
\usepackage{listings}
\usepackage{amsmath}
\usepackage{amssymb}
\newfontfamily\codefont{DejaVu Sans Mono}
\setmonofont{DejaVu Sans Mono}
\lstset{basicstyle=\small\codefont,frame=single,numbers=left}
\setCJKmainfont[Mapping = fullwidth-stop, % 中文空心句号映射为实心句点
  BoldFont=FZHei-B01,ItalicFont=FZKai-Z03,
  BoldItalicFont=FZFangSong-Z02]{FZNewShuSong-Z10}
\newcommand{\qed}{\hfill$\blacksquare$}

\begin{document}
\subsection*{2022年第三届“网鼎杯”网络安全大赛，白虎组，crypto582}

\noindent 题目说明：Simple math(flag\{*\})

\noindent 下载得到：{\small\tt{simple\_math\_b2eb263dd02cc0a22a3138fce7ddae4b.zip}}

\noindent 解压后得到以下 Python 程序 {\tt{test1.py}}。

\lstinputlisting[language=python]{test1code.py}
\newpage

\subsection*{预备知识}

\textbf{定理1}：设$x,y$是整数，$m,n$是正整数。
如果$x\equiv y\pmod{mn}$，那么$x\equiv y\pmod{m}$。

\textbf{证明}：
$x\equiv y\pmod{mn},\ $
$x-y\equiv 0\pmod{mn},\ $
$mn\,|\,x-y,\ $
$m\,|\,x-y,\ $
$x-y\equiv 0\pmod m,\ $
$x\equiv y\pmod m$。\qed

\medskip
\textbf{费马小定理}：如果$a$是正整数，$p$是素数，那么$a^p\equiv a\pmod p$。

\textbf{证明}：见《哈代数论（第~6~版）》，2021~年6~月第~1~版，
人民邮电出版社，第~66~页。\qed

\medskip
\textbf{二项式定理}：
$\displaystyle(x+y)^n=\sum_{k=0}^n{n\choose k}x^ky^{n-k}$。

\smallskip
\textbf{证明}：见《具体数学：计算机科学基础（第~2~版）》，
2013~年4~月第~1~版，人民邮电出版社，第~134~页。\qed

\subsection*{解答}

这是一道简单的数论题目。
运行 {\tt{test1.py}} 程序可以得到类似于该程序第 28--33 行的结果。
该程序第~4~行令$e=2022$，
第~5--7~行使用 {\tt{getPrime}} 函数生成 3~个大小约为
$2^{512}=10^{512\log_{10}2}\approx 10^{154}$的随机素数$m,m_1,m_2$，
第~11--24~行计算并输出以下 6~个数。
\begin{align}
\label{eq:1}c_1 &\equiv (m+m_1)^e   &&\pmod{mm_1}\\
\label{eq:2}c_2 &\equiv (m+m_2)^e   &&\pmod{mm_2}\\
\label{eq:3}c_3 &\equiv (m_1+m_2)^e &&\pmod{m_1m_2}\\
\label{eq:4}x   &\equiv (m_1+e)^m   &&\pmod{mm_1}\\
\label{eq:5}y   &\equiv (m_2+e)^m   &&\pmod{mm_2}\\
\label{eq:6}z   &\equiv (m+e)^{m_1} &&\pmod{mm_1}
\end{align}

由该程序第~8~行可知 flag$\,=m+m_1+m_2$，
因此我们需要根据以上 6~个方程解出$m,m_1,m_2$。

根据定理~1，由方程~\eqref{eq:4} 可得：
\begin{equation}
\label{eq:7}x\equiv(m_1+e)^m\pmod m
\end{equation}
根据费马小定理可得：
\begin{equation}
\label{eq:8}x\equiv m_1+e\pmod m
\end{equation}
即：
\begin{equation}
\label{eq:9}m_1\equiv x-e\pmod m
\end{equation}
由方程~\eqref{eq:5}，同理可得：
\begin{equation}
\label{eq:10}m_2\equiv y-e\pmod m
\end{equation}
根据定理~1，由方程~\eqref{eq:1} 可得：
\begin{equation}
\label{eq:11}c_1\equiv(m+m_1)^e\pmod m
\end{equation}
根据二项式定理可得：
\begin{equation}
\label{eq:12}c_1\equiv m_1^e+\sum_{k=1}^e{e\choose k}m^km_1^{e-k}\pmod m
\end{equation}
由此可得：
\begin{equation}
\label{eq:13}c_1\equiv m_1^e\pmod m
\end{equation}
将式~\eqref{eq:9} 代入式~\eqref{eq:13} 可得：
\begin{equation}
\label{eq:14}c_1\equiv (x-e)^e\pmod m
\end{equation}
即：
\begin{equation}
\label{eq:15}(x-e)^e-c_1\equiv 0\pmod m
\end{equation}
也就是：
\begin{equation}
\label{eq:16}m\,|\,(x-e)^e-c_1
\end{equation}
由方程~\eqref{eq:2} 和式~\eqref{eq:10}，同理可得：
\begin{equation}
\label{eq:17}m\,|\,(y-e)^e-c_2
\end{equation}
由式~\eqref{eq:16} 和式~\eqref{eq:17}，构造最大公因数得到：
\begin{equation}
\label{eq:18}m=\gcd\bigl((x-e)^e-c_1,(y-e)^e-c_2\bigr)
\end{equation}
我们已经解得$m$，
利用式~\eqref{eq:9} 可以得到$m_1$，
利用式~\eqref{eq:10} 可以得到$m_2$，
从而得到 flag$\,=m+m_1+m_2$。

注意，利用 {\tt{m1 = (x - e) \% m}} 计算$m_1$会导致$m_1<m$，
而这未必成立，需要再利用方程~\eqref{eq:1} 来验证。
如果计算出来的$m_1$不满足方程~\eqref{eq:1}，则$m_1$的值需要加上$m$。
计算$m_2$也同样需要再利用方程~\eqref{eq:2} 来验证。

有趣的是，解答本题不需要使用方程~\eqref{eq:3} 和方程~\eqref{eq:6}。
也就是说，题目给出的条件有冗余。
删除题目中程序 {\tt{test1.py}}
的第~13,\,17,\,21,\,24,\,30,\,33~行不影响解答。

\newpage

\noindent 根据以上分析，我们得到以下 Python 程序 {\tt{solve.py}}。

\lstinputlisting[language=python]{solve.py}


\noindent 运行 {\tt{solve.py}} 得到：

\noindent{\tt{\$ python solve.py}}

\noindent{\tt{flag\{27979a70ef9152b759d9340779256dc8\}}}

\bigskip
\noindent 本题的解法来源于：

\noindent{\tt{https://zxw-nudt.blog.csdn.net/article/details/126582089}}

\end{document}
